



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>u-boot移植（十二）---代码修改---支持DM9000网卡</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">u-boot移植（十二）---代码修改---支持DM9000网卡</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-27 15:46:18 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>一、准备工作</h1>
<h2>1.1 原理图</h2>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1142140/201706/1142140-20170619222447210-2075777914.png" /></p>
<p>　　CONFIG_DM9000_BASE</p>
<p>　　片选信号是接在nGCS4引脚，若要确定网卡的基地址，则要根据片选信号的接口去确定。</p>
<p>　　在三星2440的DATASHEET中memory control这一章的Figure 5-1. S3C2440A Memory Map after Reset 已经说明了片选4的地址，如下：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1142140/201706/1142140-20170619222850210-1855921098.png" /></p>
<p>　　只要发出的信号在 0x20000000--0x28000000 之间，就会使得片选4引脚变为低电平。所以可以确定我们网卡的基地址为0x20000000。</p>
<p>　　CONFIG_DM9000_IO 和CONFIG_DM9000_DATA</p>
<p>　　LADDR2 接在网卡的CMD引脚上，即CPU在LADDR2上发出高电平或低电平的时候可以去访问某个地址。这些地址称为IO地址和DATA地址。</p>
<p>　　LADDR2 对应 100，即为4。</p>
<p>　　之后就是位宽要确定，根据原理图，可以确定的是DM9000为16位的位宽（LDATA0~LADATA15）。那么要设置BWSCON寄存器：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1142140/201706/1142140-20170619224118273-550620097.png" /></p>
<p>　　DW4应该置1。这一项可以更改 low_level_init 中的寄存器的值进行设置。</p>
<p>　　再检查时序，时序在BANKCON4寄存器中设置，默认值也可以，寄存器也在low_level_init 中的寄存器的值进行设置。</p>
<p>　　修改下Toch的值，改为2个时钟的保持时间。</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1142140/201706/1142140-20170619225426616-755961667.png" /></p>
<h2>1.2 修改参数</h2>
<p>　　u-boot 中已经有了DM9000的驱动，即dm9000x.c，现在要将DM9000的网卡驱动加进u-boot中进行编译。</p>
<p>　　在drivers/net/Makefile文件中已经加进了dm9000x.c的编译文件，如下：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1142140/201706/1142140-20170619220144585-508757106.png" /></p>
<p>　　现在要修改include/configs/jz2440.h文件，来支持dm9000x：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1142140/201706/1142140-20170619220605991-14796974.png" /></p>
<p>　　改为：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1142140/201706/1142140-20170619225546741-701836549.png" /></p>
<p>　　编译运行一次：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1142140/201706/1142140-20170619225657835-678181048.png" /></p>
<p>　　运行成功，烧写：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1142140/201706/1142140-20170619232254898-223324179.png" /></p>
<h2>二、代码修改</h2>
<p>　　搜索：No ethernet found.</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1142140/201706/1142140-20170619233245366-1718155656.png" /></p>
<p>　　这里涉及到两个函数&nbsp;eth_initialize 和 eth_init</p>
<p>　 &nbsp; 查看board_r.c中的init_sequence_r链表，找到网路的初始化程序。</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1142140/201706/1142140-20170619234327835-218746528.png" /></p>
<p>　　进入查看：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1142140/201706/1142140-20170619234402554-1277355365.png" /></p>
<p>　　这里调用的是 eth_initialize()函数。</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1142140/201706/1142140-20170619234523491-1087670499.png" /></p>
<p>　　根据打印信息可以确定是调用的下面的那个。</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1142140/201706/1142140-20170620001638757-1289116710.png" /></p>
<p>　　由代码可以看出 &nbsp;应该是在 eth_common_init（）函数中初始化失败导致eth_devices初始化失败的。</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1142140/201706/1142140-20170620001919179-1674211278.png" /></p>
<p>　　代码中调用了board_eth_init函数Jz2440.c (board\samsung\jz2440)：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1142140/201706/1142140-20170620002133023-1665302877.png" /></p>
<p>　　这里只定义了 CONFIG_CS8900 并没有9000网卡，修改代码：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1142140/201706/1142140-20170620002623804-2073476951.png" /></p>
<p>　　编译运行：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1142140/201706/1142140-20170620005356132-1938949513.png" /></p>
<p>　　报告有错误：dm9000 address not set</p>
<p>　　MAC地址未设置。</p>
<p>　　对着打印信息查看代码，可以知道打印此条信息的代码是eth_write_hwaddr这个函数，这个函数在eth_initlize中调用：</p>
<div>
<pre class="prettyprint linenums"> int eth_write_hwaddr(struct eth_device *dev, const char *base_name,<br />
            int eth_number)<br />
 {<br />
     unsigned char env_enetaddr[];<br />
     int ret = ;

     eth_getenv_enetaddr_by_index(base_name, eth_number, env_enetaddr);

     if (!is_zero_ethaddr(env_enetaddr)) {<br />
         if (!is_zero_ethaddr(dev-&gt;enetaddr) &amp;&amp;<br />
             memcmp(dev-&gt;enetaddr, env_enetaddr, )) {<br />
             printf("\nWarning: %s MAC addresses don't match:\n",<br />
                    dev-&gt;name);<br />
             printf("Address in SROM is         %pM\n",<br />
                    dev-&gt;enetaddr);<br />
             printf("Address in environment is  %pM\n",<br />
                    env_enetaddr);<br />
         }

         memcpy(dev-&gt;enetaddr, env_enetaddr, );<br />
     } else if (is_valid_ethaddr(dev-&gt;enetaddr)) {<br />
         eth_setenv_enetaddr_by_index(base_name, eth_number,<br />
                          dev-&gt;enetaddr);<br />
     } else if (is_zero_ethaddr(dev-&gt;enetaddr)) {<br />
 #ifdef CONFIG_NET_RANDOM_ETHADDR<br />
         net_random_ethaddr(dev-&gt;enetaddr);<br />
         printf("\nWarning: %s (eth%d) using random MAC address - %pM\n",<br />
                dev-&gt;name, eth_number, dev-&gt;enetaddr);<br />
 #else<br />
         printf("\nError: %s address not set.\n",<br />
                dev-&gt;name);<br />
         return -EINVAL;<br />
 #endif<br />
     }

     if (dev-&gt;write_hwaddr &amp;&amp; !eth_mac_skip(eth_number)) {<br />
         if (!is_valid_ethaddr(dev-&gt;enetaddr)) {<br />
             printf("\nError: %s address %pM illegal value\n",<br />
                    dev-&gt;name, dev-&gt;enetaddr);<br />
             return -EINVAL;<br />
         }

         ret = dev-&gt;write_hwaddr(dev);<br />
         if (ret)<br />
             printf("\nWarning: %s failed to set MAC address\n",<br />
                    dev-&gt;name);<br />
     }

     return ret;<br />
 }</pre>
</div>
<p>　　上面定义了一个宏 &nbsp;CONFIG_NET_RANDOM_ETHADDR ，如果定义了此宏的话就会随机分配网卡物理地址，否则就打印错误信息，我们并不需要此宏。自己定义物理地址，从代码流程看，网卡地址是直接写进环境变量中的，然后再读取环境变量，这个时候就需要看看设置环境变量的地方了。</p>
<p>　　环境变量的设置在 board_r.c的链表中，initr_env函数，initr_env 会调用&nbsp;env_relocate() ，env_relocate() 调用&nbsp;set_default_env 函数，set_default_env 函数中有一个结构体&nbsp;default_environment ，这里面定义了默认的参数，进去看看一看就知道里面全部定义的是默认的环境变量参数，其中也有网络的：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1142140/201706/1142140-20170620190318163-1615275508.png" /></p>
<p>　　这里面没有物理地址的定义，所以我们可以自己定义物理地址：</p>
<p>　　在这里加入下面的内容：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1142140/201706/1142140-20170620190449538-2142076282.png" /></p>
<p>　　在 include/configs/jz2440.h 中加入 CONFIG_ETHADDR的宏 ，这里我们可以根据自己本机上的MAC地址进行定义：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1142140/201706/1142140-20170620190827632-963525341.png" /></p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1142140/201706/1142140-20170620191009866-2016320542.png" /></p>
<p>　　保存编译，查看结果：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1142140/201706/1142140-20170620193316320-1728827172.png" /></p>
<p>　　已经不会再报错网卡了。进行测试看通讯是否正常。</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1142140/201706/1142140-20170620193455054-1689286390.png" /></p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1142140/201706/1142140-20170620193747710-1679609664.png" /></p>
<p>　　已经ping 通 网卡移植完成。</p>
<p>　　</p>
<p>　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4957w5vq.html">【Android】使用属性动画碰到的困惑及讲解</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1nzy29.html">修改ubuntu DNS的步骤&sol;wget url报错： unable to resolve host address的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqld4rx9.html">The Result of an Interesting and Useful Program on Floating Numbers</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kexw38.html">How to Call SharePoint 2013 API Service to Query The Lists</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k10y469.html">jQuery 判断页面元素是否存在</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1ynxv9.html">算法库：基础线性代数子程序库（Basic Linear Algebra Subprograms，BLAS）介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wk0zvq.html">linux网络bond技术</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0epwgq.html">Android的事件处理机制详解&lpar;二&rpar;-----基于监听的事件处理机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0llrlq.html">【Spark学习】Apache Spark集群硬件配置要求</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm0mk49.html">ASP&period;NET Identity 用户注册相关设定</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydlvk2q.html">html-----012---颜色的改变</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v3moo8.html">Javascript返回顶部</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge1rxe8.html">JS，Jquery - 三元运算符</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjerw38.html">【一天一道LeetCode】&num;130&period; Surrounded Regions</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zon0yvq.html">浮点型 float和double类型的内存结构和精度问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp3ne59.html">SpringBoot微服务架构下的MVC模型总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o11vglq.html">利用正则&plus;requests爬取猫眼电影信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyvdvn9.html">luogu3119&sol;bzoj3887 草鉴定 &lpar;tarjan缩点&plus;spfa&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q252ykoq.html">Android Studio 安装与设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjv7239.html">Delphi调用java so</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8zyxp0d9.html">搭建Spark所遇过的坑</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25vljoq.html">照片 GPS 信息查询</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnv0zlj8.html">关于RabbitMQ Queue Argument的简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll74o6q.html">BZOJ2822&lbrack;AHOI2012&rsqb;树屋阶梯&mdash;&mdash;卡特兰数&plus;高精度</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll74n6q.html">BZOJ3996&lbrack;TJOI2015&rsqb;线性代数&mdash;&mdash;最小割</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25v4vwq.html">KEYENCE Programming Contest 2019 自闭记</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvx22z8.html">VMware配置Linux虚拟机访问外网</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o36de8.html">HNOI2017大佬</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rnmzz8.html">eureka集群的两种配置方式&colon;配置文件方式与DNS方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gvrg0q.html">android 混淆 与 反编译</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
